'use strict';

function loadUser(uid, cb) { setTimeout(cb, 100, null, "User" + uid); }
function loadFile(filename, cb) { setTimeout(cb, 100, null, 'Filedata' + filename); }
function markdown(filedata) { return 'html' + filedata; }
function prepareDirectory(outDirname, cb) { setTimeout(cb, 200, null, 'dircreated-' + outDirname); }
function writeOutput(html, user, cb) {  setTimeout(cb, 300, null, html + '_bytesWritten'); }
function loadEmailTemplate(cb) { setTimeout(cb, 50, null, 'emailmd'); }
function customizeEmail(user, emailHtml, cb) { return 'cust-' + user + emailHtml; }
function deliverEmail(custEmailHtml, cb) { setTimeout(cb, 100, null, 'delivered-' + custEmailHtml); }

function react(fn) {
  console.log(fn.toString());
}

var fn = react(function (R, filename, uid, outDirname, cb) {
  var filedata, outDirName, dircreated, emailmd, emailHtml,
    custEmailHtml, deliveredEmail, err, user, html, bytesWritten;
  R.async(loadUser).in(uid).out(err, user)
    .async(loadFile).in(filename).out(err, filedata)
    .sync(markdown, filedata).out(filedata)
    .async(prepareDirectory, outDirName).out(dircreated)
    .async(writeOutput, html, user).out(err, bytesWritten).after(prepareDirectory)
    .async(loadEmailTemplate).out(err, emailmd)
    .sync(markdown, emailmd).out(emailHtml)
    .sync(customizeEmail, user, emailHtml).out(custEmailHtml)
    .sync(deliverEmail, custEmailHtml).out(deliveredEmail).after(writeOutput)
    .cb(err, html, user, bytesWritten);
});
