'use strict';

var react = require('react');
var CB = react.cb;
var CBV = react.cbv;
var WAIT = react.wait;

function loadUser(uid, cb){ setTimeout(cb, 100, null, "User"+uid); }
function loadFile(filename, cb){ setTimeout(cb, 100, null, 'Filedata'+filename); }
function markdown(filedata) { return 'html'+filedata; }
function prepareDirectory(outDirname, cb){ setTimeout(cb, 200, null, 'dircreated-'+outDirname); }
function writeOutput(html, user, cb){  setTimeout(cb, 300, null, html+'_bytesWritten'); }
function loadEmailTemplate(cb) { setTimeout(cb, 50, null, 'emailmd'); }
function customizeEmail(user, emailHtml, cb) { return 'cust-'+user+emailHtml; }
function deliverEmail(custEmailHtml, cb) { setTimeout(cb, 100, null, 'delivered-'+custEmailHtml); }

function useHtml(err, html, user, bytesWritten) {
  if(err) {
    console.log('***Error: %s', err);
    return;
  }
  console.log('final result: %s, user: %s, written: %s', html, user, bytesWritten);     
}


var r = react('filename, uid, outDirname, cb').define(
    loadUser,         'uid              -> err, user',
    loadFile,         'filename         -> err, filedata',
    markdown,         'filedata         -> returns html',
    prepareDirectory, 'outDirname       -> err, dircreated', 
    writeOutput,      'html, user       -> err, bytesWritten', { after:prepareDirectory },
    loadEmailTemplate,'                 -> err, emailmd',
    markdown,         'emailmd          -> returns emailHtml',
    customizeEmail,   'user, emailHtml  -> returns custEmailHtml',
    deliverEmail,     'custEmailHtml    -> err, deliveredEmail', { after: writeOutput }
).callbackDef('err, html, user, bytesWritten');

var loadAndDeliver = react(
  function defineFromSource(filename, uid, outDirname, cb) {
    loadUser(uid, CB);
    var user = CBV();

    loadFile(filename, CB);
    var filedata = CBV();

    var html = markdown(filedata);

    prepareDirectory(outDirname, CB);
    var dircreated = CBV();

    WAIT(prepareDirectory);
    writeOutput(html, user, CB);
    var bytesWritten = CBV();

    loadEmailTemplate(CB);
    var emailmd = CBV();

    var emailHtml = markdown(emailmd);

    var custEmailHtml = customizeEmail(user, emailHtml);
    
    deliverEmail(custEmailHtml, CB);
    var deliveredEmail = CBV();

    cb(null, html, user, bytesWritten);
  }
);